cgi-exec                                                               cgi-exec

NAME
cgi-exec -- command
 
SYNOPSIS
Decode input from HTML form, initialize environmental variables,
determine script to be executed, print any relevant headers, and
execute specified script.
 
INVOCATION
<form method=post action="/cgi-bin/cgi-exec">..</form>
<a href=/cgi-bin/cgi-exec>go</a>
 
DESCRIPTION
cgi-exec preprocess data from an HTML form and redirects the data to a
CGI script specified in a database located in a resource directory for
cgi-exec.  cgi-exec acquires the input from the browser, regardless of
method, decodes the input into plain text, places that input into
environmental variables corresponding to the fieldnames designated in
the HTML form; it then searches the database cgi-exec.db to determine
the name of the script to be executed to process the form data.
Overwriting existing environmental variables is disallowed.
 
OPTION
cgi-exec no longer allows command line options. Its options are now
given to it through the text database file that resides inside a
resource directory for cgi-exec.

cgi-exec will locate its resource directory in the following fashion.
Using the cgi-bin directory as the current working directory, cgi-exec
will look for the existence of the following directories in this order:

  ../../cgi-exec
  ../cgi-exec

The first directory found to exist will override the default of the
cgi-bin directory itself, which will be used in the event that neither
of these directories are found.  Thereafter all cgi-exec resources
will be pulled from this directory, including the text database file,
and the scripts named in that file.

The text database is called cgi-exec.db, and should not be writable by
the process executing the binary, usually "httpd".  It contains three
fields separated by single tab characters.  Each record is terminated
with a single newline character.

An example database might look like this:

http_referer	cgi_script	header
------------	----------	------
index.html	environ.cgi	text
test.shtml	test01.cgi	html
trial.html	xpdq15.sh	none

The first field, called http_referer, contains the basename of the
document containing the HTML <form> that referred it to cgi-exec.
This value is derived from the browser-generated environmental
variable called HTTP_REFERER.  The contents of the variable
HTTP_REFERER are not always reliable, so the first field might also
(and probably more usefully) contain the value of the hidden variable
REF_DOC placed by the author of the document into the HTML <form>.
 
The second field, called cgi_script, contains the basename of the
script that cgi-exec is to spawn after it decodes its input and puts
it into its environment.  This script is presumed to reside in the
cgi-exec resource directory described above; although an absolute path
name will be honored.  The script must both exist and be executable by
the process invoking cgi-exec, i.e., "httpd".  This "script" can be a
shell script, or any interperter script, or even a binary executable.

The third field, called header, controls the type of header that
cgi-exec emits immediately prior to executing the cgi_script named in
the second field.  This field has three legal values: "text", "html",
and "none".  Any value other than these is ignored, and the default
header type is emitted, which is "text".

  html - text/html header output before execution of script, and HTML
         footer output after execution.
  text - text/plain header output before execution of script.
  none - no header or footer output before or after execution of script.

Please note that the name of the text database varies according to the
name which the administrator gives to the executable.  If the
executable is called cgi-debug, then the name of the database will be
cgi-debug.db.  When the executable is renamed, the database must be
renamed accordingly.  The name of the cgi-exec resource directory
does not change in this fashion.

EXAMPLE
<form method=post action="/cgi-bin/cgi-exec">
  <input type=hidden name=REF_DOC value=index.html>
  <input type=text name=Name size=40 maxlength=40> Name<br>
  <input type=text name=EMail size=40 maxlength=40> E-Mail<br>
  <input type=submit value=submit><br>
  <input type=reset value=reset><br>
</form>
 
SEE ALSO

NOTES
The preferred method to use when invoking cgi-exec is METHOD=POST.
This keeps the output of the form from being visible in the browser.
But METHOD=GET is also allowed.  In the example above, assuming that
the form is first filled out before submission, cgi-exec will set the
following environmental variables before executing the script
specified in cgi-exec.db:
  REF_DOC=index.html
  Name='William F. Simmons'
  EMail=wfs@simtech-soft.com
REF_DOC should be set as indicated above, with the value being the
name of the referring HTML document.

Error Messages

All error messages emitted by cgi-exec when compiled in standard
run-time (non-debug) mode use symbolic names for files to prevent
divulging potentially compromising information to a remote user.  The
following table will help clarify this intentionally misleading
speech.

cgi_dir         full pathname of cgi-bin directory
script_dir      full pathname of the cgi-exec resource directory
cgi_exec        current basename of the cgi-exec executable
cgi_exec_db     current basename of the cgi-exec.db database
http_referer    contents of HTTP_REFERER
ref_doc         contents of REF_DOC
cgi_script      basename of script in cgi-bin directory
cgi_scriptname  full path of cgi-script

Copyright (c) 2000, 2003 William F. Simmons.  All rights reserved. 

